<template>
  <div class="mt-2 d-flex justify-content-end">
    <div class="">
      <button type="button" class="fs-7 btn btn-secondary mx-1 mt-4 p-2 px-2 mb-4" @click="goToLecturaCuentas()">
        <i class="fa-regular fa-eye me-1"></i> LECTURA ARCHIVO
      </button>
    </div>
    <div class=" ps-2">
      <button type="button" class="fs-7 btn btn-secondary mx-1 mt-4 p-2 px-2 mb-4" @click="goToPedidosCuenta()">
        <i class="bi bi-plus-square me-1 fs-7"></i> NUEVO PEDIDO
      </button>
    </div>
  </div>
  <table class="table table-striped" v-if="pedidoCuentaStore.listadoPedidoCabecera.length > 0">
    <thead>
      <tr>
        <th scope="col">NRO PEDIDO</th>
        <th scope="col">DESCRIPCION</th>
        <th scope="col">FECHA</th>
        <th scope="col">ARCHIVO</th>
        <th scope="col">CANTIDAD</th>
        <th scope="col">PROCESADOS</th>
        <th scope="col">USUARIO</th>
        <th scope="col">ACCIONES</th>
      </tr>
    </thead>
    <tbody>
      <tr v-for="cabecera in pedidoCuentaStore.listadoPedidoCabecera" :key="cabecera.id_baprocab">
        <td v-text="cabecera.id_baprocab"></td>
        <td v-text="cabecera.d_tipo_proceso"></td>
        <!-- <td v-text="formatDate(cabecera.f_genera)"></td> -->
        <td v-text="formatDate(cabecera.f_segu)"></td>
        <td v-text="cabecera.archivo"></td>
        <td v-text="cabecera.cantidad"></td>
        <td v-text="cabecera.procesados"></td>
        <td v-text="cabecera.clave"></td>
        <td>
          <button class="btn btn-principal btn-sm pt-0 pb-0 px-1 mb-2 mt-0 mx-1" alt="Detalle" title="Detalle"
            @click="showModalDetalle(cabecera)">
            <i class="bi bi-search"></i>
          </button>

          <button v-show="cabecera.puede_revertir == 1" class="btn btn-principal btn-sm pt-0 pb-0 px-1 mb-2 mt-0 mx-1"
            alt="Revertir" title="Revertir" @click="revertir(cabecera.id_baprocab, cabecera.f_genera)">
            <i class="bi bi-arrow-90deg-left"></i>
          </button>

<!--           <a :href="respaldoImprimir()//pasar uno por uno como necesite el jasper
            " target="_blank" title="Imprimir" alt="Imprimir"
            class="btn btn-principal btn-sm pt-0 pb-0 px-1 mb-2 mt-0 mx-1">
            <i class="bi bi-printer"></i>
          </a> -->
        </td>
      </tr>
    </tbody>
  </table>
  <div v-else class="alert alert-secondary" role="alert">
    No hay elementos para mostrar
  </div>

  <Modal ref="detalleModal" :title="'Detalle Pedido de Cuentas '+ formatDate(data.cabecera?.f_segu)" size="xl" :vertical-centered="true">
    <DetallePedidoCuenta @close-modal="hideModalDetalle" :cabecera="data.cabecera"></DetallePedidoCuenta>
  </Modal>
</template>
    
<script setup lang="ts">

//librerias
import { reactive, ref } from "vue";
import { useRouter } from "vue-router";
import { loading, urlApi, getUrl } from "@/shared.js";
import http from "@/http";
import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions } from "sweetalert2";
import { Modal } from "@hcd-bsas/vue3-components";
//import { AxiosError } from "axios";
import type { AxiosError } from "axios";
import { DateTime } from "luxon";
//entities
import type Pedido from "@/entities/Bapro/PedidosCuenta/Pedidocabecera";
//store
import { usepedidosCuentaStore } from "@/stores/Bapro/PedidoCuentas/pedidosCuenta";
import { useConfigStore } from "@/stores/configgral";

//component
import DetallePedidoCuenta from "@/components/Bapro/PedidosCuenta/DetallePedidoCuenta.vue";


const router = useRouter();
const configStore = useConfigStore();
const pedidoCuentaStore = usepedidosCuentaStore();
const detalleModal = ref<typeof Modal>();


/* function formatDate(date: string | null) {
    if (date != null) {
        // return moment(date).format("DD/MM/YYYY");
        return DateTime.fromISO(date).toLocaleString();
    }
} */

//ver en la libreria
function formatDate(date: string | null) {

  if (date != null) {
    const fecha = date;
    const dt = DateTime.fromFormat(fecha, "yyyy-MM-dd HH:mm:ss.SSS");
    const fechaFormateada = dt.toFormat("dd/MM/yyyy");
    return fechaFormateada;
  }
}

const data = reactive({
  cabecera: undefined as Pedido | undefined,
  //isLoading: true,
});

function goToPedidosCuenta() {
  router.push({
    name: "genear-archivo",
  });
}
function goToLecturaCuentas() {
  router.push({
    name: "inicioLecturaCuentas",
  });
}

function revertir(ID: number, fecha: string) {

  const swal_error: SweetAlertOptions<any, any> = {
    icon: "error",
    title: "Error",
    html: "",
  }
  Swal.fire({
    icon: "question",
    title: "Confirmaci&oacute;n",
    html: "¿Confirma revertir el Pedido de cuentas de la fecha " + formatDate(fecha) + "? Esta acci&oacute;n no podr&aacute; ser revertida.",
    showCancelButton: true,
    confirmButtonColor: "#3085d6",
    cancelButtonColor: "#d33",
    confirmButtonText: "Confirmar",
    cancelButtonText: "Cancelar",
  }).then(async (result) => {
    if (result.isConfirmed) {
      loading.show();
      var rta = await http.post(urlApi + "deletePedidoCuentasBapro", {
        id_baprocab: ID,
      }).then(async () => {
        Swal.fire({
          icon: "success",
          text: "Se Borro el Archivo Correctamente.",
        })
        await configStore.updateListadoPeriodo();
        var anio = configStore.listadoPeriodoActivo[0]?.anioActivo;
        var fecha_desde = anio + "-03-01";
        var fecha_hasta = anio + "-12-31";
        await pedidoCuentaStore.updateListadoCargosCabecera({
          f_desde: fecha_desde,
          f_hasta: fecha_hasta,
        });
        loading.hide();
      }).catch(function (error: AxiosError<string, any>) {
        if (error.response) {
          // Request made and server responded
          swal_error.html =
            error.message +
            " (" +
            error.code +
            ")." +
            "<br />" +
            error.response.data.substring(
              error.response.data.indexOf("<h2>") + 4,
              error.response.data.indexOf("</h2>")
            );
          console.log("Error: request made and server responded");
          console.log(swal_error.html);
          console.log(error.response);
        } else if (error.request) {
          // The request was made but no response was received
          swal_error.html =
            "Error desconocido. Por favor, avise al Administrador.";
          console.log("Error: the request was made but no response was received");
          console.log(error.request);
        } else {
          // Something happened in setting up the request that triggered an Error
          swal_error.html =
            "Error desconocido. Por favor, avise al Administrador.";
          console.log(
            "Error: something happened in setting up the request that triggered an error"
          );
          console.log(error);
        }
        loading.hide();
        Swal.fire(swal_error);
      });

    }
  })
}

function showModalDetalle(cabecera: Pedido) {
  data.cabecera = cabecera;
  detalleModal.value!.show();
}

function hideModalDetalle() {
  detalleModal.value!.hide();
}

/* function respaldoImprimir() {
  var queryParams: any = {
    id_baprocab:data.cabecera?.id_baprocab,
  }
  console.log("antes del GETURL", queryParams);
  return getUrl('respaldoImprimir', [], queryParams);

} */

</script> 
<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>